=== changelog ===
alsa-lib (1.0.23-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add refcount-dlobjs.patch: backported upstream patch, originally by
    Jaroslav Kysela, to fix crashes when plugins are unloaded.
    (Closes: #589896, LP: #552411, #584393)
  * Add libtool-out-of-tree.patch: fix libtool version checking for the biarch
    build by grepping ltmain.sh in the ${srcdir}, making it unnecessary to
    force -DUSE_VERSIONED_SYMBOLS for the biarch build

 -- Simon McVittie <smcv@debian.org>  Fri, 08 Oct 2010 08:30:54 +0100

alsa-lib (1.0.23-2) unstable; urgency=medium

  [ Elimar Riesebieter ]
  * Make setlocale() thread safe:
    Applied thread-safe-locale.patch and thread-specific-locale.patch from
    upstream. (Closes: #595252)
  * Bump Standards-Version to 3.9.1, with no changes required.

 -- Jordi Mallach <jordi@debian.org>  Wed, 22 Sep 2010 12:22:18 +0200

alsa-lib (1.0.23-1) unstable; urgency=low

  * New upstream release.

  [ Elimar Riesebieter ]
  * Add powerpcspe to the list of supported architectures. Hint by Sebastian
    Andrzej Siewior. (closes: #583615)
  * Introduced DEP-3 patch headers.
  * Patch Dont_leak_timer_fd_on_pcm_slave_close.patch applied from upstream.
    Removed.

  [ Jordi Mallach ]
  * Remove lpia from the list of supported architectures, as it's not used
    by Ubuntu anymore.

 -- Jordi Mallach <jordi@debian.org>  Wed, 02 Jun 2010 20:21:04 +0200

alsa-lib (1.0.22-2) unstable; urgency=low

  [ Jordi Mallach ]
  * Bump Standards-Version to 3.8.4, with no changes required.

  [ Elimar Riesebieter]
  * Readded -DUSE_VERSIONED_SYMBOLS only to the bibuild CFLAGS.
    (Closes: #570703)

 -- Jordi Mallach <jordi@debian.org>  Sun, 21 Feb 2010 01:03:48 +0100

alsa-lib (1.0.22-1) unstable; urgency=low

  * New upstream release. (Closes: #549531)

  [ Jordi Mallach ]
  * Remove lintian overrides file; it only contains an obsolete entry.

  [ Daniel T Chen ]
  * debian/control: Add sparc64 to Architecture field for libasound2{,-dev}
    using patch from Aurelien Jarno. Thanks! (Closes: #560405)
  * debian/patches/Dont_leak_timer_fd_on_pcm_slave_close.patch: Properly
    free timer fd when closing pcm slaves. Backported from upstream master
    HEAD (LP: #451893) (Closes: #568101)

  [ Elimar Riesebieter]
  * Switched to source version 3.0.
  * As we are defining CFLAGS in rules -D_GNU_SOURCE added as suposed in
    original Makefile.
  * Removed -DUSE_VERSIONED_SYMBOLS from CFLAGS. It is used in the build system
    now.
  * Removed lintian file installation from rules.

 -- Jordi Mallach <jordi@debian.org>  Thu, 11 Feb 2010 21:24:39 +0100

alsa-lib (1.0.21a-1) unstable; urgency=low

  [ Elimar Riesebieter ]
  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Mon, 14 Sep 2009 21:56:13 +0200

alsa-lib (1.0.21-1) unstable; urgency=low

  * New upstream release.
    + libasound2: Division by zero in pcm_rate.c when period_size->min == 0.
      Patch from John Lindgren applied upstream. Thanks! (closes: #539454)

  [ Elimar Riesebieter ]
  * Enable AM_MAINTAINER_MODE in a way where it actually has effect.
    Thanks Lionel Elie Mamane. (closes: #505088)
  * libasound2-dev: Don't install unneeded .la files. Bump shlibs to >> 1.0.20.
  * Added README.sources.
  * Updated changelog.ALSA and patches.

  [ Jordi Mallach ]
  * Revert .la removal after discussion with the Release Team. Instead,
    clear dependency_libs until all the depending packages have dropped the
    reverse dependency.

 -- Jordi Mallach <jordi@debian.org>  Thu, 10 Sep 2009 12:09:48 +0200

alsa-lib (1.0.20-4) unstable; urgency=low

  [ Elimar Riesebieter ]
  * Conflicts: libc6-i386 (<= 2.9-18) to lib32asound2 and lib32asound2-dev as
    suggested by Aurelien Jarno. (closes: #538835)

  [ Jordi Mallach ]
  * Update Standards-Version to 3.8.3. No changes needed.

 -- Jordi Mallach <jordi@debian.org>  Fri, 28 Aug 2009 11:37:38 +0200

alsa-lib (1.0.20-3) unstable; urgency=low

  [ Jordi Mallach ]
  * Build-Depend on python-dev instead of python2.4-dev, as suggested
    by Steve Langasek (closes: #532044).

  [ Elimar Riesebieter ]
  * Move files in /emul/ia32-linux to /usr/lib32 as suggested by Clint Adams.
  * Pre-Depends: libc6-i386 (>= 2.9-18) (closes: #533005)
  * Bumped Standards-Version to 3.8.2. No changes.

 -- Jordi Mallach <jordi@debian.org>  Wed, 24 Jun 2009 13:40:03 +0200

alsa-lib (1.0.20-2) unstable; urgency=medium

  [ Elimar Riesebieter ]
  * Added -DUSE_VERSIONED_SYMBOLS to CFLAGS. This make sure the symbols
    associated to ALSA_0.9.0rc4 and ALSA_0.9.0rc8 are back in lib32asound2.
    (closes: #529940)
  * Removed duplicated 'Section' fields in debian/control.

 -- Jordi Mallach <jordi@debian.org>  Fri, 29 May 2009 01:56:26 +0200

alsa-lib (1.0.20-1) unstable; urgency=low

  * New upstream release.

  [ Elimar Riesebieter ]
  * Added lib(32|64)asound2-plugins to lib(32|64)asond2 suggestions. Thanks Jan
    Muszynski. (closes: #523420)
  * Added avr32 to Architectures. Thanks Bradley Smith for the hint.
    (closes: #528667)
  * Replaced "dh_clean -k" with "dh_prep"
  * Bumped Standard-Version to 3.8.1; no changes needed.
  * All patches refreshed.

 -- Jordi Mallach <jordi@debian.org>  Thu, 21 May 2009 02:34:29 +0200

alsa-lib (1.0.19-1) unstable; urgency=low

  * New upstream release.
  * Upload to unstable.

  [ Elimar Riesebieter ]
  * Install asoundrc.txt as an example. (closes: #505090)
  * Added libcxxtools-dev to Build-Depends

  [ Jordi Mallach ]
  * Change configure calls to use --build instead of --host to correct
    the biarch build for alsa-lib. Thanks to Andreas Metzler and
    Neil Williams for the advice (closes: #516585).

 -- Jordi Mallach <jordi@debian.org>  Wed, 04 Mar 2009 01:44:12 +0100

alsa-lib (1.0.18-1) experimental; urgency=low

  * New upstream release.

  [ Jordi Mallach ]
  * Improve libasound2's short description following suggestions by
    Dan Chen and Barry deFreese. Thanks! (closes: #493512)

  [ Elimar Riesebieter ]

