=== debian/changelog ===
ia32-libs-core (20110202) stable; urgency=low

  [ Goswin von Brederlow ]
  * Do not disable secure APT when downloading packages.
  * Add fix for duplicate sources due to security updates.
  * Add security repository next to the regular Debian mirror.
  * Welcome Thijs Kinkhorst to the team.

  * Packages updated

  [ eglibc (2.11.2-10) unstable; urgency=low ]

  * Add patches/amd64/cvs-avx-tcb-alignment.diff from upstream to fix
    alignement issues on CPU supporting the AVX instruction set. 
    #610657.

  [ eglibc (2.11.2-9) unstable; urgency=low ]

  * Disable build failure in case of testsuite regressions, will be
    re-enabled after squeeze release.

  [ eglibc (2.11.2-8) unstable; urgency=low ]

  [ Clint Adams ]
  * Japanese debconf translation update from Nobuhiro Iwamatsu.
    #604752.

  [ Samuel Thibault ]
  * Add expected gettext failure on hurd-i386.

  [ Aurelien Jarno ]
  * Update patches/localedata/locale-et_EE.diff to switch Estonian currency
    to euro. #608803.
  * Revert incorrect upstream patch for CVE-2010-3847 and use the correct
    set of patches:
    - Remove patches/any/submitted-origin.diff
    - Add patches/any/cvs-dont-expand-dst-twice.diff
    - Add debian/patches/any/cvs-ignore-origin-privileged.diff
    - Keep debian/patches/any/cvs-audit-suid.diff

  [ ncurses (5.7+20100313-5) unstable; urgency=low ]

  * New patch 01-debian-kfreebsd-terminfo.patch, adding a cons25-debian
    terminfo entry to ncurses-base for the Debian GNU/kfreebsd console
    (#607662).

 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 02 Feb 2011 21:38:44 +0100

ia32-libs-core (20101207) unstable; urgency=high

  [ Goswin von Brederlow ]
  * Sync fetch-and-build script with ia32-libs / ia32-libs-gtk.
    One script fits all.
  * Readd Breaks statement as per policy 7.6.1.
	
  * Packages updated

  [ gcc-4.4 (4.4.5-8) unstable; urgency=low ]

  * Update to SVN 20101114 from the gcc-4_4-branch (r166728).
    - Fix PR middle-end/43690, PR tree-optimization/46107, PR libgfortran/46373,
      PR fortran/45742.
  * Don't hardcode debian/patches when referencing patches. Addresses: #600502.

  [ gcc-4.4 (4.4.5-7) unstable; urgency=low ]

  * Update to SVN 20101111 from the gcc-4_4-branch (r166584).
    - Fix PR target/46419 (wrong code), PR libgfortran/46010 (wrong code).

  [ Thorsten Glaser ]
  * debian/rules2: Re-enable multi{arch,lib} on m68k.
  * debian/patches/m68k-multilib.diff: new, select which multi{arch,lib}
    targets to build: keep 680x0 drop cpu32/fidoa (possibly re-evaluated
    later but [Bug gas/12180] suggests both do not run Linux anyway).
  * debian/patches/pr37053.diff: new, backported from trunk.
  * debian/patches/pr46179.diff: new, taken from GCC BZ.
  * debian/patches/pr39531.diff: new, taken from git URL from fthain.
  * debian/patches/pr41064.diff: new, backported from trunk.
  * debian/rules.patch: Add m68k-multilib, pr37053, pr46179, pr39531,
    pr41064 on m68k. (pr37053 and pr41064 go together to avoid regressions.)
  * debian/rules.defs: remove m68k from locale_no_cpus.

  [ icu (4.4.1-7) testing-proposed-updates; urgency=high ]

  * Apply patch to fix Malayam rendering.  (#591615)

 -- Goswin von Brederlow <goswin-v-b@web.de>  Tue, 07 Dec 2010 17:33:45 +0100

ia32-libs-core (20101117) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Replace lib32icu42 with lib32icu44.
  * Update Packages:
    + alsa-lib  1.0.22-2       -> 1.0.23-2.1
    + blcr      0.8.2-13       -> 0.8.2-15
    + bzip2     1.0.5-4        -> 1.0.5-6
    + eglibc    2.10.2-9       -> 2.11.2-7
    + gcc       4.4_4.4.4-1    -> 4.4_4.4.5-6
    + icu       4.2.1-3        -> 4.4.1-6
    + libffi    3.0.9-2        -> 3.0.9-3
    + ncurses   5.7+20100313-2 -> 5.7+20100313-4
 
 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 17 Nov 2010 11:36:10 +0100

ia32-libs-core (20100610) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Convert to 3.0 (native) format.
  * Add debian/source/options to ignore locale files.

  [ Frederik Schüler ]
  * Update to debhelper 7.
    - use dh_prep instead of dh_clean -k
  * Add dependency on ${misc:Depends}.
  * Add lintian overides.

 -- Frederik Schüler <fs@debian.org>  Thu, 10 Jun 2010 17:00:37 +0200

ia32-libs-core (20100421) unstable; urgency=low

  * Split ia64 specific packages from ia32-libs into ia32-libs-core.

 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 21 Apr 2010 09:09:11 +0200

ia32-libs (20090808) unstable; urgency=low

  * Update packages.
  * Automatically generate copyright file.  Closes: #540199, #505625.
  * Add libuuid1.  Closes: #540489, #540339, #539746.
  * Bump shlibs version to 20090808.  Closes: #540184.
  * B-D on dctrl-tools instead of grep-dctrl.  Closes: #505631.
  * Add locale symlink.  Thanks to Martin Pitt.  Closes: #505627.
  * Use ROOT/SUFFIX consistently in debian/rules.  Thanks to Martin Pitt.
    Closes: #505632.

 -- Mark Hymers <mhy@debian.org>  Sat, 08 Aug 2009 18:12:19 +0100

ia32-libs (20090804) unstable; urgency=low

  * Re-upload monolithic package.
  * Drop gdk-imlib1, gdk-imlib11, libcap1, libfusionsound-1.0-0, libxcb-xlib0
  * Bump libdirectfb to 1.2-0 from 1.0-0, libltdl3 to libltdl7
  * Replace libkrb53 with libkrb5support0, libkrb5-3, libk5crypto3,
    libgssapi-krb5-2

 -- Mark Hymers <mhy@debian.org>  Tue, 04 Aug 2009 21:35:25 +0100

ia32-libs (2.7) unstable; urgency=low

  * Freshen packages.
  * Drop libgnutls13 and libopencdk10: removed from lenny.

 -- Frederik Schüler <fs@debian.org>  Wed, 03 Sep 2008 20:40:18 +0200

ia32-libs (2.6) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Fix echo -e bashism in debian/rules (Closes: 484391)

  [ Frederik Schüler ]
  * drop libldap2 and liblzo1.
  * Add libxcb1, libxcb-xlib0, libxcb-render0 and libxcb-render-util0 -
    new dependencies from libaudio2.
  * Replace libcupsys2 with libcups2.
  * Freshen packages.

 -- Frederik Schüler <fs@debian.org>  Wed, 23 Jul 2008 13:36:03 +0200

ia32-libs (2.5) unstable; urgency=low


