=== debian/control ===
Source: ia32-libs-core
Section: libs
Priority: extra
Maintainer: Debian ia32-libs Team <pkg-ia32-libs-maintainers@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>, Goswin von Brederlow <goswin-v-b@web.de>, Frederik Schüler <fs@debian.org>, Thijs Kinkhorst <thijs@debian.org>
Build-Depends: debhelper (>> 7.0.0), dpkg-dev (>= 1.15.7.2), lsb-release, dctrl-tools
Standards-Version: 3.8.4
Vcs-Browser: http://git.debian.org/?p=pkg-ia32-libs/ia32-libs-core.git
Vcs-Git: git://git.debian.org/git/pkg-ia32-libs/ia32-libs-core.git

Package: ia32-libs-core
Architecture: ia64
Pre-Depends: dpkg (>= 1.13.21)
Depends: ${misc:Depends}
Replaces: ia32-libs (<< 20100418), ia32-libs-dev (<< 1.6), nvidia-glx-ia32 (<< 1.0.8774-7)
Breaks: ia32-libs (<< 20100418), nvidia-glx-ia32 (<< 1.0.8774-7)
Conflicts: ia32-libs-dev
Suggests: ia32-libs
Description: core ia32 shared libraries for use on ia64 systems
 This package contains runtime linker and core libraries for the ia32/i386
 architecture, configured for use on an ia64 Debian system.
