=== watch ===
version=3
https://ftg.lbl.gov/CheckpointRestart/downloads/blcr-(\d\.\d\.\d).tar.gz
